#include "MyDefines.h"
#include myPATH(MY_INCLUDES_DIR,AuxCompFunctions.h)

#include "BlockMwITransform.h"


BlockMwITransform::BlockMwITransform()
{

}


void BlockMwITransform::Init(int mmin, int mmax, int treshold)
{
	t = treshold;
	min = mmin;
	max = mmax;
}



vector<int> BlockMwITransform::Interleave(int v)
{
	vector<int> A;

	A.push_back(v);
	for (int i = 1; i <= t; i++)
	{
		if (v + i <= max)
			A.push_back(v + i);
		if (v - i >= min)
			A.push_back(v - i);
	}

	return A;
}


void BlockMwITransform::InsertInL(int v)
{
	int flg = 0;
	for (int i = 0; i < (int)L.size(); i++)
		if (L[i] == v)
			flg = 1;

	if (!flg)
		L.push_back(v);
}

void BlockMwITransform::SetL(int a, int b, int c, int d)
{
	L.clear();
	vector<int> A = Interleave(a);
	vector<int> B = Interleave(b);
	vector<int> C = Interleave(c);
	vector<int> D;
	if (d != -1)
		D = Interleave(d);

	int l = (int)A.size();
	if (l < (int)B.size())
		l = (int)B.size();

	if (l < (int)C.size())
		l = (int)C.size();

	if (l < (int)D.size())
		l = (int)D.size();


	for (int i = 0; i < l; i++)
	{
		if (i < (int)A.size())
			InsertInL(A[i]);

		if (i < (int)B.size())
			InsertInL(B[i]);

		if (i < (int)C.size())
			InsertInL(C[i]);

		if (i < (int)D.size())
			InsertInL(D[i]);
	}

	int Lmin = max;
	int Lmax = min;

	for (int i = 0; i < (int)L.size(); i++)
	{
		if (L[i] < Lmin)
			Lmin = L[i];
		if (L[i] > Lmax)
			Lmax = L[i];
	}



	for (int i = Lmin + 1; i < Lmax; i++)
		InsertInL(i);

	int half = (int)( 0.5 * (max - min));
	if (Lmin > half)
	{
		for (int i = Lmax + 1; i <= max; i++)
			L.push_back(i);

		for (int i = 0; i < Lmin; i++)
			L.push_back(i);
	}
	else
	{
		for (int i = 0; i < Lmin; i++)
			L.push_back(i);

		for (int i = Lmax + 1; i <= max; i++)
			L.push_back(i);
	}

}


int BlockMwITransform::TransformMwI(int x, int a, int b, int c, int d)
{
	SetL(a, b, c, d);
	int p = 0;
	while (x != L[p])
		p++;

	return p;
}

int  BlockMwITransform::MwIDe(int a, int b, int c, int d, int p)
{
	SetL(a, b, c, d);
	return L[p];
}