#include <stdio.h>
#include <string.h>
#include <vector>

#include "MyDefines.h"

#include myPATH(MY_INCLUDES_DIR,MyRawImageData.h)
#include myPATH(MY_INCLUDES_DIR,AuxCompFunctions.h)
//#include myPATH(MY_INCLUDES_DIR,SimplePredictors.h)
//#include myPATH(MY_INCLUDES_DIR,UkkonenBwt.h)
//#include myPATH(MY_INCLUDES_DIR,MTFWithIntegers.h)
//#include myPATH(MY_INCLUDES_DIR,MwI.h)

#include "MySegmentation.h"
#include "MyRBlock.h"
#include "MyDeRBlock.h"
#include "ReducedSet.h"

//#define PRINTOUT 0


#pragma warning (disable : 4996)

using namespace std;

int ReducedSetInfo[NO_OF_IMAGES][11];

int GetPredictionJPEGLS(vector<vector<int>>& ImageData, int x, int y)
{
	if (x == 0)
		return ImageData[x][y - 1];

	int a = ImageData[x][y - 1];
	int c = ImageData[x - 1][y - 1];
	int b = ImageData[x - 1][y];

	if ((c > a) && (c > b))
		if (a < b)
			return a;
		else
			return b;

	if ((c < a) && (c < b))
		if (a > b)
			return a;
		else
			return b;

	int d = a + b - c;
	return d;
}

vector<vector<int>> ReturnPredictionJPEGLS(int W, int H, vector<vector<int>>& I)
{
	int x, y;

	vector<vector<int>> P = AllocateMatrix(W, H);
	P[0][0] = I[0][0];

	for (x = 1; x < W; x++)
		P[x][0] = I[x][0] - I[x - 1][0];

	for (y = 1; y < H; y++)
		for (x = 0; x < W; x++)
			P[x][y] = GetPredictionJPEGLS(I, x, y) - I[x][y];

	return P;
}




int GetPredictionCALIC(int x, int y,int RBorder,  vector<vector<int>>& I)
{

	if ((x == 0) && (y == 0))
		return I[0][0];

	if (y == 0)
		return I[x][0] - I[x - 1][0];

	if (y == 1)
		return GetPredictionJPEGLS(I, x, y);

	if (x == 0)
		return I[0][y] - I[0][y - 1];

	if (x == 1)
		return GetPredictionJPEGLS(I, x, y);

	if (x >= RBorder - 2)
		return GetPredictionJPEGLS(I, x, y);

	double W = I[x - 1][y];
	double NW = I[x - 1][y - 1];
	double N = I[x][y - 1];
	double NE = I[x + 1][y - 1];
	double NN = I[x][y - 2];
	double NNE = I[x + 1][y - 2];
	double WW = I[x - 2][y];

	double dh = abs(W - WW) + abs(N - NW) + abs(NE - N);
	double dv = abs(W - NW) + abs(N - NN) + abs(NE - NNE);


	if (dv - dh > 80) return (int)W;
	if (dv - dh < -80) return (int)N;

	double m = ((int)(W + N) / 2) + ((int)(NE - NW) / 4);

	if (dv - dh > 32) return ((int)(m + W) / 2);
	if (dv - dh > 8) return ((int)(3 * m + W) / 4);
	if (dv - dh < -32) return ((int)(m + N) / 2);
	if (dv - dh < -8) return ((int)(3 * m + N) / 4);

	return (int)m;
}

vector<vector<int>> ReturnPredictionCALIC(int W, int H, vector<vector<int>> I)
{
	int x, y;

	vector<vector<int>> P = AllocateMatrix(W, H);

	for (y = 0; y < H; y++)
		for (x = 0; x < W; x++)
			P[x][y] = GetPredictionCALIC(x, y, W, I) - I[x][y];

	return P;
}



vector<vector<int>> MatrixToPositiveValues(int W, int H, vector<vector<int>> M)
{
	int x, y;
	int first = M[0][0];

	vector<vector<int>> P = AllocateMatrix(W, H);

	for (y = 0; y < H; y++)
		for (x = 0; x < W; x++)
			P[x][y] = ToPositiveValue(M[x][y]);

	P[0][0] = first;
	return P;
}

/*
void SolveBaboon(MyRBlock& Blk, int BlockSize, int W, int H)
{
	int HminIndex = 0;
	int sum;
	int SumMin;

	for (int x = 0; x < W; x += BlockSize)
		for (int y = 0; y < H; y += BlockSize)
		{
			SumMin = 10000;
			Blk.SetBlock(x, y);

			Blk.HorizontalPrediction();
			sum = Blk.GetHorizontalBlockSum();

			if (sum <= SumMin)
			{
				SumMin = sum;
				HminIndex = HORIZONTAL_BLOCK;
			}

			Blk.UpLeftAverage();
			sum = Blk.GetUpLeftAverageSum();

			if (sum <= SumMin)
			{
				SumMin = sum;
				HminIndex = UPLEFT_BLOCK;
			}

			Blk.Calic();
			sum = Blk.GetCalicSum();
			if (sum <= SumMin)
			{
				SumMin = sum;
				HminIndex = CALIC_BLOCK;
			}

			Blk.Statistic(HminIndex);
			Blk.StoreBest(HminIndex);
		}
}

void SolveBallons(MyRBlock& Blk, int BlockSize, int W, int H)
{
	int HminIndex = 0;
	int sum;
	int SumMin;

	for (int x = 0; x < W; x += BlockSize)
		for (int y = 0; y < H; y += BlockSize)
		{
			SumMin = 10000;
			Blk.SetBlock(x, y);

			Blk.UpLeftAverage();
			sum = Blk.GetUpLeftAverageSum();

			if (sum <= SumMin)
			{
				SumMin = sum;
				HminIndex = UPLEFT_BLOCK;
			}

			Blk.JPEGLJPrediction();
			sum = Blk.GetJPEGLSBlockSum();

			if (sum <= SumMin)
			{
				SumMin = sum;
				HminIndex = JPEGLS_BLOCK;
			}


			Blk.Calic();
			sum = Blk.GetCalicSum();
			if (sum <= SumMin)
			{
				SumMin = sum;
				HminIndex = CALIC_BLOCK;
			}

			Blk.Statistic(HminIndex);
			Blk.StoreBest(HminIndex);
		}

}
*/
int main()
{
	printf("OJ! \n\n");



	MyRawImageData MRID;

	int ImageIndex = MRID.SelectImage();
	if (ImageIndex == 99) return 1;
	if (ImageIndex == 0)
		return 1;
	else
	{
		if (MRID.LoadBMP())
		{
			int AllTransform = 0;
			printf("1..All transforms \n");
			printf("2..Reduced set \n");			
			scanf("%d", &AllTransform);

			vector<vector<int>>Image = MRID.ReturnImageData();
			double HOriginal = MRID.ReturnEntropy();
//			printf("Original H: %f \n", MRID.ReturnEntropy());

			int H = MRID.ReturnHeight();
			int W = MRID.ReturnWidth();

//			PrintMatrix(Image, "Image.TXT");

			vector<vector<int>> M = ReturnPredictionJPEGLS(W, H, Image);
			vector<vector<int>> MPlus = MatrixToPositiveValues(W, H, M);
			double HJPG = CalculateEntropy(DoMatrixStatistic(H, W, MPlus));
//			printf("Global JPEGLS Predictor H: %f \n", HJPG);

				//			PrintMatrix(MPlus, "JPGLS.TXT");

			vector<vector<int>> C = ReturnPredictionCALIC(W, H, Image);
			vector<vector<int>> CPlus = MatrixToPositiveValues(W, H, C);
			double HCALIC = CalculateEntropy(DoMatrixStatistic(H, W, CPlus));
//			printf("Global CALIC Predictor H: %f \n", HCALIC);
			printf("--------------------------\n");



			MyRBlock Blk;
			int BlockSize = 8;
			int BlockCounter = 0;

			printf("Block size: %d x %d \n", BlockSize, BlockSize);



			int HminIndex;
			int MwIDelta = 12;
			double IDWd = 9;
			double SumMinH = 0;
			int SumMin;
			int sum;

			Blk.Init(W, H, BlockSize, MwIDelta, IDWd, Image);
//			Blk.PrintOToFile("O.txt");

			if (AllTransform == 1)
			{
				for (int x = 0; x < W; x += BlockSize)
					for (int y = 0; y < H; y += BlockSize)
					{

						//					if (BlockCounter < 50)
							//				{

						Blk.SetBlock(x, y);
						Blk.RawPrediction();
#ifdef PRINTOUT
						printf("Block %d (%d,%d) \n", BlockCounter, x, y);
#endif // PRINTOUT

						SumMin = sum = Blk.GetRawBlockSum();
						HminIndex = RAW_BLOCK;


						Blk.JPEGLJPrediction();
						sum = Blk.GetJPEGLSBlockSum();

						if (sum <= SumMin)
						{
							SumMin = sum;
							HminIndex = JPEGLS_BLOCK;
						}


						Blk.HorizontalPrediction();
						sum = Blk.GetHorizontalBlockSum();

						if (sum <= SumMin)
						{
							SumMin = sum;
							HminIndex = HORIZONTAL_BLOCK;
						}

						Blk.VerticalPrediction();
						sum = Blk.GetVerticalBlockSum();


						if (sum <= SumMin)
						{
							SumMin = sum;
							HminIndex = VERTICAL_BLOCK;
						}

						Blk.MTF();
						sum = Blk.GetMTFBlockSum();

						if (BlockCounter == 3)
							sum = 0;

						if (sum <= SumMin)
						{
							SumMin = sum;
							HminIndex = MTF_BLOCK;
						}


						Blk.BlockMwI();
						sum = Blk.GetMwIBlockSum();

						if (sum <= SumMin)
						{
							SumMin = sum;
							HminIndex = MWI_BLOCK;
						}

						Blk.Diagonal();
						sum = Blk.GetDiagonalBlockSum();

						if (sum <= SumMin)
						{
							SumMin = sum;
							HminIndex = DIAGONAL_BLOCK;
						}


						Blk.IDW();
						sum = Blk.GetIDWSum();
						if (sum <= SumMin)
						{
							SumMin = sum;
							HminIndex = IDW_BLOCK;
						}

						Blk.UpLeftAverage();
						sum = Blk.GetUpLeftAverageSum();
						if (sum <= SumMin)
						{
							SumMin = sum;
							HminIndex = UPLEFT_BLOCK;
						}

						Blk.Paeth();
						sum = Blk.GetPaethSum();
						if (sum <= SumMin)
						{
							SumMin = sum;
							HminIndex = PAETH_BLOCK;
						}


						Blk.Calic();
						sum = Blk.GetCalicSum();
						if (sum <= SumMin)
						{
							SumMin = sum;
							HminIndex = CALIC_BLOCK;
						}
						/*
												Blk.Akima();
												sum = Blk.GetAkimaSum();
												if (sum <= SumMin)
												{
													SumMin = sum;
													HminIndex = AKIMA_BLOCK;
												}
						*/
						Blk.Statistic(HminIndex);
						Blk.StoreBest(HminIndex);

						BlockCounter++;
					}

				//				}
			}
			else // reduced set
			{
				vector<int> AP;
				AP.resize(NO_OF_PREDICTORS);
				
				switch (ImageIndex)
				{
				case  1: AP[1] = AP[4] = AP[10] = 1; break;
				case  2: AP[4] = AP[9] = AP[10] = 1; break;
				case  3: AP[2] = AP[7] = AP[10] = 1; break;
				case  4: AP[2] = AP[4] = AP[10] = 1; break;
				case  5: AP[4] = AP[9] = AP[10] = 1; break;
				case  6: AP[4] = AP[7] = AP[10] = 1; break;
				case  7: AP[7] = AP[9] = AP[10] = 1; break;
				case  8: AP[4] = AP[7] = AP[10] = 1; break;
				case  9: AP[4] = AP[7] = AP[10] = 1; break;
				case 10: AP[4] = AP[9] = AP[10] = 1; break;
				case 11: AP[4] = AP[9] = AP[10] = 1; break;
				case 12: AP[4] = AP[9] = AP[10] = 1; break;
				case 13: AP[2] = AP[4] = AP[10] = 1; break;
				case 14: AP[4] = AP[9] = AP[10] = 1; break;
				case 15: AP[2] = AP[4] = AP[10] = 1; break;
				case 16: AP[4] = AP[9] = AP[10] = 1; break;
				case 17: AP[4] = AP[9] = AP[10] = 1; break;
				case 18: AP[4] = AP[7] = AP[10] = 1; break;
				case 19: AP[4] = AP[9] = AP[10] = 1; break;
				case 20: AP[2] = AP[4] = AP[10] = 1; break;
				case 21: AP[4] = AP[9] = AP[10] = 1; break;
				case 22: AP[6] = AP[8] = AP[10] = 1; break;
				case 23: AP[4] = AP[9] = AP[10] = 1; break;
				case 24: AP[4] = AP[6] = AP[10] = 1; break;
				case 25: AP[4] = AP[9] = AP[10] = 1; break;
				case 26: AP[4] = AP[7] = AP[10] = 1; break;
				case 27: AP[4] = AP[9] = AP[10] = 1; break;
				case 28: AP[2] = AP[4] = AP[10] = 1; break;
				case 29: AP[6] = AP[8] = AP[9]  = 1; break;
				case 30: AP[4] = AP[7] = AP[10] = 1; break;
				case 31: AP[1] = AP[9] = AP[10] = 1; break;
				case 32: AP[2] = AP[4] = AP[10] = 1; break;

				}

				BlockCounter = SolveIndividual(Blk, BlockSize, W, H, AP);


			/*	switch (ImageIndex)
				{
				case 1: SolveBaboon(Blk, BlockSize, W, H); break;
				case 2: SolveBallons(Blk, BlockSize, W, H); break;
				case 3: SolveBarb(Blk, BlockSize, W, H); break;
				case 4: SolveBarbara(Blk, BlockSize, W, H); break;
				case 5: SolveBark(Blk, BlockSize, W, H); break;
				case 6: SolveBoard(Blk, BlockSize, W, H); break;

				} */




			}

			Blk.PrintStatistic();
			Blk.PrintStatisticRow();
			printf("\n");
			printf("H original   : %5.3f\n", HOriginal);
			printf("H only JPEGLS: %5.3f \n", HJPG);
			printf("H only CALIC : %5.3f \n", HCALIC);
			printf("H Block      : %5.3f\n", Blk.FinalEntropy());
			printf("\n");
			printf("| %8.3f   | %7.3f  | %6.3f  | %6.3f  | \n", HOriginal, HJPG, HCALIC, Blk.FinalEntropy());
			//			Blk.PrintOToFile("OFinal.txt");

		
			if (AllTransform == 2)
			{
				vector<char> VB = Blk.DetermineControlBits();

				printf("\n");
				printf("No of pixels %d\n", H * W);
				printf("No of blocks %d\n", BlockCounter);
				printf("No of control pixels %d\n", (int)VB.size());


				int cjp = (int)(HJPG * H * W / 8);
				printf("\nJPEG_LS bytes: %d \n", cjp);

				int cc = (int)(HCALIC * H * W / 8);
				printf("CALIC bytes: %d \n", cc);

				double HBlokR = Blk.FinalEntropy();
				printf("H Block Reduced %f \n", HBlokR);

				
				vector<char> ABC;
				ABC.push_back('0'); ABC.push_back('1');
				double hb = CalculateEntropy(ABC, VB);
				printf("H control bits %f \n", hb);




				int cb = (int)(HBlokR * H * W / 8);
				printf("Block bytes %d \n", cb);
				int hControlB = (int)(hb * VB.size() /8);

				printf("Control bytes %d \n", hControlB);
				printf("total bytes by blocks %d \n", cb + hControlB);


				printf("\n\n    Q   |   SoCB   |  H_SoCB  |     BB   |    BCp  | BB+BCp  | JPEGLS  | CALIC \n");
				printf("%7d | %8d | %8.3f | %8d | %7d | %7d | %7d | %7d\n", BlockCounter, (int)VB.size(), hb, cb, 
					hControlB, cb + hControlB, cjp, cc);


			}



			Blk.Save("Common.txt");

			MyDeRBlock DeBlk;
			if (DeBlk.Init("Common.txt") == 0)
				printf("\n ------> File not found \n");
			else
			{
				vector<vector<int>> DeM = DeBlk.RestorePixels();
				if (DeM == Image)
					printf("\n Decoded correctly!\n");
				else
					printf("\n ---->Decoded Wrongly!\n");
			}
			

		}

	}
	
	return 1;
}
