#pragma once
#include <vector>
#include "MyDefines.h"
#include myPATH(MY_INCLUDES_DIR,AuxCompFunctions.h)

#include "MyRBlockDefs.h"


class MyDeRBlock
{
private:
	int W, H;
	int BSize;
	int MwIDelta;
	double IDWDistance;
	int x1, y1, x2, y2, dx, dy;

	vector<int> ControlVector;
	vector<vector<int>> P; // stored prediction values
	vector<vector<int>> R; // reconstructed values

	void SetBlockCoordinates(int x, int y);
	vector<int> FillBlockBorderValues();

	void ReconstructLUBorder();
//	void ReconstructRawBlock(int x, int y, int minV);

	void ReconstructRawBlock(int x, int y);
	int GetPredictionJPEGLSDe(int x, int y);
	void ReconstructJPEGLS(int x, int y);
	void ReconstructHorizontal(int x, int y);
	void ReconstructVertical(int x, int y);
	void ReconstructMTF(int x, int y);
	void ReconstructMwI(int x, int y);
	void ReconstructDiagonal(int x, int y);
	void ReconstructIDW(int x, int y);
	void ReconstructUpLeftAverage(int x, int y);

	int GetPaethPrediction(int i, int j);
	void ReconstructPeath(int x, int y);

	int GetPredictionCALICDe(int x, int y);
	void ReconstructCALIC(int x, int y);

public:
	MyDeRBlock() {};
	int Init(const char* fname);
	vector<vector<int>> RestorePixels();
};


