#include "MySegmentation.h"
#include <stdio.h>
#include <string.h>
#include <vector>

#include "MyDefines.h"
#include myPATH(MY_INCLUDES_DIR,AuxCompFunctions.h)


#pragma warning (disable : 4996)



MySegmentation::MySegmentation() 
{ 

}

void MySegmentation::Init(int w, int h, vector<vector<int>>& Img)
{
	W = w;
	H = h;
	I = Img;
	rL = rH = 0;
}



void MySegmentation::CreateBitmap(int a, int b)
{
	vector<vector<int>> B = AllocateMatrix(W, H);

	for (int x = 0; x < W; x++)
		for (int y = 0; y < H; y++)
			if ((I[x][y] >= a) && (I[x][y] <= b))
				B[x][y] = 1;
			else
				B[x][y] = 0;

	PrintMatrix(B, "BM.TXT");
}

void MySegmentation::MakeBitmap(int treshold)
{
	
	B = AllocateMatrix(W, H);

	int a = 0;

	printf("Skupaj pikslov %d\n", W * H);
	int bc = 0;
	int wc = 0;
	for (int x = 0; x < W; x++)
		for (int y = 0; y < H; y++)
			if (I[x][y] > treshold)
			{
				B[x][y] = BBlack;
				bc++;
			}
			else
			{
				B[x][y] = BUndefined;
				wc++;
			}
	
	printf("B %d  W %d \n", bc, wc);

	PrintMatrix(B, "MyB.txt");

	/*
	W = 15;
	H = 10;

	B = AllocateMatrix(W, H);
	for (int x = 0; x < W; x++)
		for (int y = 0; y < H; y++)
			B[x][y] = BUndefined;

	B[0][0] = BBlack;
	B[1][7] = BBlack;
	B[2][4] = BBlack;
	B[4][2] = BBlack;
	B[6][7] = BBlack;
	B[7][6] = BBlack;
	B[7][8] = BBlack;
	B[8][7] = BBlack;
	B[9][0] = BBlack;
	B[10][4] = BBlack;
	B[12][1] = BBlack; */
}

void MySegmentation::RepresentByBoxes()
{

	int x, y;
	y = 0;
	R.clear();
	x = 0;
	int ax, ay;
	int EndFlag = 0;
	int temp = 0;

	do 
	{ 
		temp++;
		if ((temp % 100)== 0)
		{
			printf("%d %d %d \n", x, y, temp);

		}
		while ((x < W) && (B[x][y] != BUndefined))
		{
			if (B[x][y] == BBlack)
				R.push_back(BBlack);
			x++;
		}

		
		if (x == W)
		{
			if (y == H - 1)
				EndFlag = 1;
			else
			{
				y++;
				x = 0;
			}
		}
		else
		{
			DetermineWhiteRegion(x, y, ax, ay);
			FillArea(x, y, ax, ay, BWhite);
			InsertCommands(x, y, ax, ay);

			PrintMatrix(B, "BitMap.txt");

			if (ax < W-1)
				x = ax + 1;
			else
			{
				x = 0;
				y++;
			}
		}
	} while (!EndFlag);
}


void  MySegmentation::DetermineWhiteRegion(int x1, int y1, int& x2, int& y2)
// the first coordinaate is (x1,y1); the second if exist is to the right and bottom

{
	int xFirst = x1;

	while ((xFirst < W) && (B[xFirst][y1] == BUndefined))
		xFirst++;

	x2 = xFirst - 1;
	y2 = y1 + 1;
	if (y2 < H)
	{
		int flag = 1;
		int x;
		while (flag)
		{
			x = x1;
			while ((x < W) && (x < xFirst) && (B[x][y2] == BUndefined))
				x++;

			if (x < xFirst)
			{
				flag = 0;
				y2--;
			}
			else
				if (y2 == H - 1)
					flag = 0;
				else
					y2++;
		}
	}
	else
		y2--;
}

void MySegmentation::FillArea(int x1, int y1, int x2, int y2, int t)
{
	for (int x = x1; x <= x2; x++)
		for (int y = y1; y <= y2; y++)
			B[x][y] = t;

}

void MySegmentation::InsertCommands(int x1, int y1, int x2, int y2)
{
	if (x2 == W - 1)
	{
		int a = x2 - x1 + y2 - y1;
		for (int i = 0; i < a; i++)
			R.push_back(BWhite);
		R.push_back(BEnd);
	}
	else
	{
		int i;
		for (i = x1; i < x2; i++)
			R.push_back(BWhite);
		R.push_back(BTurn);
		for (i = y1; i < y2; i++)
			R.push_back(BWhite);
		R.push_back(BEnd);
	}
}


void MySegmentation::MarkBloks(int Bsize, int treshold)
// Mark bloks of size BSize with 1 if at least one element is larger that treshold, otherwise it is marked with 0
{
	int xs, ys, x, y;
	int allSmall;
	R.clear();
	int X, Y;
	for (xs = 0; xs < W; xs+=Bsize)
		for (ys = 0; ys < H; ys+=Bsize)
		{
			allSmall = 1;
			X = xs + Bsize;
			if (X > W - 1)
				X = W - 1;

			Y = ys + Bsize;
			if (Y > H - 1)
				Y = H - 1;

			for (x = xs; x < X; x++)
				for (y = ys; y < Y; y++)
				{
					if (I[x][y] > treshold)
					{
						printf("x,y,v (%d,%d)=%d\n", x, y, I[x][y]);
						allSmall = 0;
					}
				}

			R.push_back(allSmall);

		}

	for (int i = 0; i < R.size(); i++)
		printf("%d\n", R[i]);
	

	

}