#pragma once
#include "ReducedSet.h"


void SolveBaboon(MyRBlock& Blk, int BlockSize, int W, int H)
{
	int HminIndex = 0;
	int sum;
	int SumMin;

	for (int x = 0; x < W; x += BlockSize)
		for (int y = 0; y < H; y += BlockSize)
		{
			SumMin = 10000;
			Blk.SetBlock(x, y);

			Blk.HorizontalPrediction();
			sum = Blk.GetHorizontalBlockSum();

			if (sum <= SumMin)
			{
				SumMin = sum;
				HminIndex = HORIZONTAL_BLOCK;
			}

			Blk.UpLeftAverage();
			sum = Blk.GetUpLeftAverageSum();

			if (sum <= SumMin)
			{
				SumMin = sum;
				HminIndex = UPLEFT_BLOCK;
			}

			Blk.Calic();
			sum = Blk.GetCalicSum();
			if (sum <= SumMin)
			{
				SumMin = sum;
				HminIndex = CALIC_BLOCK;
			}

			Blk.Statistic(HminIndex);
			Blk.StoreBest(HminIndex);
		}
}

void SolveBallons(MyRBlock& Blk, int BlockSize, int W, int H)
{
	int HminIndex = 0;
	int sum;
	int SumMin;

	for (int x = 0; x < W; x += BlockSize)
		for (int y = 0; y < H; y += BlockSize)
		{
			SumMin = 10000;
			Blk.SetBlock(x, y);

			Blk.UpLeftAverage();
			sum = Blk.GetUpLeftAverageSum();

			if (sum <= SumMin)
			{
				SumMin = sum;
				HminIndex = UPLEFT_BLOCK;
			}

			Blk.JPEGLJPrediction();
			sum = Blk.GetJPEGLSBlockSum();

			if (sum <= SumMin)
			{
				SumMin = sum;
				HminIndex = JPEGLS_BLOCK;
			}


			Blk.Calic();
			sum = Blk.GetCalicSum();
			if (sum <= SumMin)
			{
				SumMin = sum;
				HminIndex = CALIC_BLOCK;
			}

			Blk.Statistic(HminIndex);
			Blk.StoreBest(HminIndex);
		}
}

void SolveBarb(MyRBlock& Blk, int BlockSize, int W, int H)
{
	int HminIndex = 0;
	int sum;
	int SumMin;

	for (int x = 0; x < W; x += BlockSize)
		for (int y = 0; y < H; y += BlockSize)
		{
			SumMin = 10000;
			Blk.SetBlock(x, y);

			Blk.HorizontalPrediction();
			sum = Blk.GetHorizontalBlockSum();
			if (sum <= SumMin)
			{
				SumMin = sum;
				HminIndex = HORIZONTAL_BLOCK;
			}

			Blk.IDW();
			sum = Blk.GetIDWSum();
			if (sum <= SumMin)
			{
				SumMin = sum;
				HminIndex = IDW_BLOCK;
			}

			Blk.Calic();
			sum = Blk.GetCalicSum();
			if (sum <= SumMin)
			{
				SumMin = sum;
				HminIndex = CALIC_BLOCK;
			}

			Blk.Statistic(HminIndex);
			Blk.StoreBest(HminIndex);
		}
}


void SolveBarbara(MyRBlock& Blk, int BlockSize, int W, int H)
{
	int HminIndex = 0;
	int sum;
	int SumMin;

	for (int x = 0; x < W; x += BlockSize)
		for (int y = 0; y < H; y += BlockSize)
		{
			SumMin = 10000;
			Blk.SetBlock(x, y);

			Blk.UpLeftAverage();
			sum = Blk.GetUpLeftAverageSum();
			if (sum <= SumMin)
			{
				SumMin = sum;
				HminIndex = UPLEFT_BLOCK;
			}


			Blk.HorizontalPrediction();
			sum = Blk.GetHorizontalBlockSum();
			if (sum <= SumMin)
			{
				SumMin = sum;
				HminIndex = HORIZONTAL_BLOCK;
			}


			Blk.Calic();
			sum = Blk.GetCalicSum();
			if (sum <= SumMin)
			{
				SumMin = sum;
				HminIndex = CALIC_BLOCK;
			}

			Blk.Statistic(HminIndex);
			Blk.StoreBest(HminIndex);
		}
}

void SolveBark(MyRBlock& Blk, int BlockSize, int W, int H)
{
	int HminIndex = 0;
	int sum;
	int SumMin;

	for (int x = 0; x < W; x += BlockSize)
		for (int y = 0; y < H; y += BlockSize)
		{
			SumMin = 10000;
			Blk.SetBlock(x, y);

			Blk.UpLeftAverage();
			sum = Blk.GetUpLeftAverageSum();
			if (sum <= SumMin)
			{
				SumMin = sum;
				HminIndex = UPLEFT_BLOCK;
			}


			Blk.JPEGLJPrediction();
			sum = Blk.GetJPEGLSBlockSum();

			if (sum <= SumMin)
			{
				SumMin = sum;
				HminIndex = JPEGLS_BLOCK;
			}


			Blk.Calic();
			sum = Blk.GetCalicSum();
			if (sum <= SumMin)
			{
				SumMin = sum;
				HminIndex = CALIC_BLOCK;
			}

			Blk.Statistic(HminIndex);
			Blk.StoreBest(HminIndex);
		}
}

void SolveBoard(MyRBlock& Blk, int BlockSize, int W, int H)
{
	int HminIndex = 0;
	int sum;
	int SumMin;

	for (int x = 0; x < W; x += BlockSize)
		for (int y = 0; y < H; y += BlockSize)
		{
			SumMin = 10000;
			Blk.SetBlock(x, y);

			Blk.UpLeftAverage();
			sum = Blk.GetUpLeftAverageSum();
			if (sum <= SumMin)
			{
				SumMin = sum;
				HminIndex = UPLEFT_BLOCK;
			}


			Blk.IDW();
			sum = Blk.GetIDWSum();
			if (sum <= SumMin)
			{
				SumMin = sum;
				HminIndex = IDW_BLOCK;
			}


			Blk.Calic();
			sum = Blk.GetCalicSum();
			if (sum <= SumMin)
			{
				SumMin = sum;
				HminIndex = CALIC_BLOCK;
			}

			Blk.Statistic(HminIndex);
			Blk.StoreBest(HminIndex);
		}
}


int SolveIndividual(MyRBlock& Blk, int BlockSize, int W, int H, vector<int> AP)
{
	int HminIndex;
	int sum;
	int SumMin;
	int BlockCounter = 0;

	for (int x = 0; x < W; x += BlockSize)
		for (int y = 0; y < H; y += BlockSize)
		{

			SumMin = 10000;
			HminIndex = 0;

			Blk.SetBlock(x, y);

			

			if (AP[0] == 1)
			{
				Blk.RawPrediction();
				SumMin = sum = Blk.GetRawBlockSum();
				HminIndex = RAW_BLOCK;
			}

			if (AP[1] == 1)
			{
				Blk.VerticalPrediction();
				sum = Blk.GetVerticalBlockSum();
				if (sum <= SumMin)
				{
					SumMin = sum;
					HminIndex = VERTICAL_BLOCK;
				}
			}


			if (AP[2] == 1)
			{
				Blk.HorizontalPrediction();
				sum = Blk.GetHorizontalBlockSum();
				if (sum <= SumMin)
				{
					SumMin = sum;
					HminIndex = HORIZONTAL_BLOCK;
				}
			}


			if (AP[3] == 1)
			{
				Blk.Diagonal();
				sum = Blk.GetDiagonalBlockSum();
				if (sum <= SumMin)
				{
					SumMin = sum;
					HminIndex = DIAGONAL_BLOCK;
				}
			}


			if (AP[4] == 1)
			{

				Blk.UpLeftAverage();
				sum = Blk.GetUpLeftAverageSum();
				if (sum <= SumMin)
				{
					SumMin = sum;
					HminIndex = UPLEFT_BLOCK;
				}
			}


			if (AP[5] == 1)
			{
				Blk.MTF();
				sum = Blk.GetMTFBlockSum();
				if (sum <= SumMin)
				{
					SumMin = sum;
					HminIndex = MTF_BLOCK;
				}
			}


			if (AP[6] == 1)
			{
				Blk.BlockMwI();
				sum = Blk.GetMwIBlockSum();

				if (sum <= SumMin)
				{
					SumMin = sum;
					HminIndex = MWI_BLOCK;
				}
			}



			if (AP[7] == 1)
			{

				Blk.IDW();
				sum = Blk.GetIDWSum();
				if (sum <= SumMin)
				{
					SumMin = sum;
					HminIndex = IDW_BLOCK;
				}
			}


			if (AP[8] == 1)
			{

				Blk.Paeth();
				sum = Blk.GetPaethSum();
				if (sum <= SumMin)
				{
					SumMin = sum;
					HminIndex = PAETH_BLOCK;
				}
			}

			if (AP[9] == 1)
			{
				Blk.JPEGLJPrediction();
				sum = Blk.GetJPEGLSBlockSum();
				if (sum <= SumMin)
				{
					SumMin = sum;
					HminIndex = JPEGLS_BLOCK;
				}
			}


			if (AP[10] == 1)
			{

				Blk.Calic();
				sum = Blk.GetCalicSum();
				if (sum <= SumMin)
				{
					SumMin = sum;
					HminIndex = CALIC_BLOCK;
				}
			}

			Blk.Statistic(HminIndex);
			Blk.StoreBest(HminIndex);
			BlockCounter++;
		}


		return BlockCounter;
}